[![Build Status](https://travis-ci.org/duereg/js-algorithms.png)](https://travis-ci.org/duereg/js-algorithms)
[![Dependencies](https://david-dm.org/duereg/js-algorithms.png)](https://david-dm.org/duereg/js-algorithms)
[![devDependencies](https://david-dm.org/duereg/js-algorithms/dev-status.png)](https://david-dm.org/duereg/js-algorithms#info=devDependencies&view=table)

JS-Algorithms
=============

Classic data structures and algorithms (with tests!) written in JavaScript

* Singly Linked List
* Min/Max Binary Heap
* Trie (With Pre-Order Traversal Sorting)
* Stack (push, pop, peek, and isEmpty)
* Queue (add, remove, peek, isEmpty)
* Binary Search Tree
* Hash Table

As well as the following algorithms:

* Breadth First Search
* Depth First Search
* Binary Search
* Merge Sort
* Quick Sort

Various problems will be solved to show how to use these basic algorithms and data structures.

The process of creating this code is documented [here](http://blog.mattblair.co).

##Usage

If you want access to these basic data structures in your project, include this package.

```shell
> var dataStructures = require('js-algorithms')
> dataStructures
{ binaryHeap: [Function],
  binarySearchTree: [Function: bst],
  linkedList: [Function],
  maxHeap: [Function],
  minHeap: [Function],
  queue: [Function],
  stack: [Function],
  stackQueue: [Function],
  trie: [Function] }
```


